;;; Code zum Discographie-Beispiel

;;; die freie Var. dg speichert die Discographie

(setq dg nil)


;;; list erzeugt eine cd-struktur
;;; cons fuegt diese vorne in dg ein

(defun cd-aufnehmen (cd-titel interpret)
  (setq dg (cons (list cd-titel interpret nil) 
                 dg)
  )
)


;;; eine cd sei durch ihren titel eindeutig identifiziert
;;; mapcar iteriert ueber die CDs, ist der Titel einer
;;; cd gleich dem Wert cd-titel, dann wird ein neuer
;;; track erzeugt (list) und vorne an die Trackliste
;;; eingefgt

(defun neuer-track (cd-titel track-titel dauer)
  (setq dg
    (mapcar #'(lambda (cd)
                (cond ((equal (car cd) cd-titel) 
                       (list (car cd)
                             (cadr cd)
                             (cons (list track-titel dauer) 
                                   (caddr cd))
                       ))
                      (T cd)
                )
              ) dg
    )
  )
)



;;; liefert die cd-Struktur fr einen cd-titel

(defun suche-cd (dg cd-titel)
  (cond ((null dg) nil)
        (T (cond ((equal (caar dg) cd-titel) (car dg))
                 (T (suche-cd (cdr dg) cd-titel))))
  )
)

;;; sucht zuerst die gewuenschte CD
;;; iteriert dann ueber die track-Liste und sammelt alle
;;; Spielzeiten der Tracks in einer Liste.
;;; Um die Spieldauer einer CD zu berechnen, wird diese Liste
;;; zu einen +-Ausdruck erweitert (cons)
;;; Dieser wird mithilfe von eval ausgewertet und zurueckgegeben

(defun spieldauer (cd-titel)
  (let ((cd (suche-cd dg cd-titel))
       )
       (cond ((null cd) 0)
             (T (eval(cons '+
                           (mapcar #'(lambda (track) (cadr track))
                                   (caddr cd)
                            )))
             )
       )
  )
)

;;; Diese Funktion nutzt die spieldauer-Funktion
;;; Die Berechnung der Gesamtspieldauer einer DG erfolgt
;;; analog.

(defun gesamtdauer nil
   (cond ((null dg) 0)
         (T(eval (cons '+
                      (mapcar #'(lambda (cd) 
                                  (spieldauer(car cd))) dg
                       )
                 )
            )
          )
   )
)

;;; zeigt den Einsatz von mapc um Seiteneffekte zu erzielen

(defun drucke-cd (cd)
  (let ((titel (car cd))
        (interpret (cadr cd))
        (tracks (caddr cd))
        )
        (write-string "TITEL    : ") (prin1 titel)       (terpri)
        (write-string "INTERPRET: ") (prin1 interpret)   (terpri)
        (mapc #'(lambda (track)
                  (write-string "  ")(prin1 (car track)) (terpri)
                 )
              tracks
         )
  )
)

(defun drucke-dg nil
  (mapc #'drucke-cd dg)
  nil
)



(cd-aufnehmen 'songs 'klaus)
(cd-aufnehmen 'lieder 'peter)

(neuer-track 'lieder 'lied1 65)
(neuer-track 'lieder 'lied2 71)
(neuer-track 'songs 'song1 10)
(neuer-track 'songs 'song2 20)
