MODULE DisplayableRectangle EXPORTS DisplayableRectangle;

(* ObjektModul DisplayableRectangle, dieses Objekt bernimmt die 
   ausgabe fr die Klasse Rectangel.
Autor : Horst Lichter, RWTH Aachen
Umgebung : SRC-Modula-3 rel. 3.6, Windows NT 4.0
Erstellt : 16.08.98
Letzte Aenderung: 09.01.2001
*)

IMPORT Rectangle; 	(* Ober Klasse wird importiert *)
TYPE SuperT =Rectangle.T; 

REVEAL 			(* Aufdeckung und erweiterung des Objekts *)
  T = Public BRANDED OBJECT
        color : TEXT;
      OVERRIDES		(* Methoden werden redefiniert *)
        setColor := SetColor;
        getColor := GetColor;
        asText := AsText;
        draw := Draw;
      END;

PROCEDURE AsText(self : T) : TEXT =
(* Gibt die Zahlenwerte als Text aus *)
VAR t : TEXT;
BEGIN
  t := SuperT.asText(self);		 (* Die in der Super Klasse definierte AsText Funktion wir aufgerufen *)
  RETURN (t & " color: " & self.color ); (* alle werte werden als TEXT gespeichert und zurck gegeben *)
END AsText;

PROCEDURE Draw (self : T) : TEXT =
(* Gibt den TEXT draw zurck *)
BEGIN
  RETURN "draw";
END Draw;

PROCEDURE GetColor(self : T): TEXT =
(* Gibt den mit SetColor gesetzten Wert zurck *)
BEGIN
  RETURN self.color;
END GetColor;

PROCEDURE SetColor(self: T; c : TEXT) =
(* Setzt die Instanz Variable Color *)
BEGIN
  self.color := c;
END SetColor;


BEGIN
END DisplayableRectangle.
